<!--
  ~ EVS Client is part of the Gazelle Test Bed
  ~ Copyright (C) 2006-2016 IHE
  ~ mailto :eric DOT poiseau AT inria DOT fr
  ~
  ~ See the NOTICE file distributed with this work for additional information
  ~ regarding copyright ownership.  This code is licensed
  ~ to you under the Apache License, Version 2.0 (the
  ~ "License"); you may not use this file except in compliance
  ~ with the License.  You may obtain a copy of the License at
  ~
  ~   http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing,
  ~ software distributed under the License is distributed on an
  ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~ KIND, either express or implied.  See the License for the
  ~ specific language governing permissions and limitations
  ~ under the License.
  -->

<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:h="http://java.sun.com/jsf/html" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:rich="http://richfaces.org/rich" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:c="http://java.sun.com/jstl/core"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:param name="pageName" value="#{messages['gazelle.evs.client.admin.manage.standards']}"/>
    <ui:param name="pageNameUrl" value="administration/referencedStandardDisplay.seam"/>
    <ui:param name="pageNameTitle" value="#{messages['net.ihe.gazelle.evs.ReferencedStandardDefinition']}"/>
    <ui:define name="body">
        <ui:decorate template="/layout/form/_form_page.xhtml">

            <h:form id="globalForm">


                <s:div id="globalDiv">
                    <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">
                        <ui:define name="panel_title">
                            <h:outputText value="#{messages['net.ihe.gazelle.evs.AddReferencedStandard']}"
                                          rendered="#{referencedStandardBeanGui.isCreation()}"/>
                            <h:outputText value="#{messages['net.ihe.gazelle.evs.EditReferencedStandard']}"
                                          rendered="#{!referencedStandardBeanGui.isCreation()}"/>
                        </ui:define>

                        <div class="form-horizontal">

                            <h:outputText
                                    value="#{messages['net.ihe.gazelle.evs.BeCarefulTheValueOfThelabelFieldIsUsedAsKeyInJav']}"/>
                            <s:decorate id="labelDecoration" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                <ui:param name="id" value="labelId"/>
                                <ui:define name="label">#{messages['net.ihe.gazelle.evs.DisplayName']}</ui:define>
                                <h:inputText id="labelId" size="30" maxlength="128"
                                             value="#{referencedStandardBeanGui.selectedReferencedStandard.name}" required="true" styleClass="form-control">
                                    <a4j:ajax event="blur" render="labelDecoration" execute="@this"/>
                                </h:inputText>
                            </s:decorate>

                            <s:decorate id="nameDecoration" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                <ui:param name="id" value="selectNameId"/>
                                <ui:define name="label">#{messages['net.ihe.gazelle.evs.ValidatorType']}</ui:define>
                                <h:selectOneMenu id="selectNameId" value="#{referencedStandardBeanGui.selectedReferencedStandard.validationType}"
                                                 required="true" styleClass="form-control gzl-form-control gzl-select-text"
                                                 valueChangeListener="#{referencedStandardBeanGui.initValidationType}">
                                    <f:selectItems value="#{referencedStandardBeanGui.getValidatorFriendlyNamesAsSelectItems()}"/>
                                    <a4j:ajax event="change" render="nameDecoration validationServices availableValidationServices" execute="@this"/>
                                </h:selectOneMenu>
                            </s:decorate>

                            <h:outputText
                                    value="#{messages['net.ihe.gazelle.evs.BeCarefulTheValueOfTheextensionFieldMayBeUsedAsD']}"/>
                            <s:decorate id="extensionDecoration" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                <ui:param name="id" value="extensionId"/>
                                <ui:define name="label">#{messages['net.ihe.gazelle.evs.ValidatorFilter']}</ui:define>
                                <h:inputText id="extensionId" size="30" maxlength="128"
                                             value="#{referencedStandardBeanGui.selectedReferencedStandard.validatorFilter}" styleClass="form-control">
                                    <a4j:ajax event="blur" render="extensionDecoration" execute="@this"/>
                                </h:inputText>
                            </s:decorate>

                            <s:decorate id="descriptionDecoration" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                <ui:param name="id" value="descriptionId"/>
                                <ui:define name="label">#{messages['gazelle.evs.client.Description']}</ui:define>
                                <ui:decorate template="/layout/editor/_text_editor.xhtml">
                                    <ui:param name="text" value="#{referencedStandardBeanGui.selectedReferencedStandard.description}"/>
                                    <ui:param name="id" value="descriptionId"/>
                                    <ui:param name="isFocus" value="true"/>
                                </ui:decorate>
                            </s:decorate>
                            <s:decorate id="iconPathDecoration" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                <ui:param name="id" value="iconPathId"/>
                                <ui:define name="label">#{messages['net.ihe.gazelle.EVSClient-ui.NameOfFontIconToUsefaFawrenchForExample']})
                                </ui:define>
                                <!--
                                <h:inputText id="iconPathId" value="#{referencedStandardBeanGui.selectedReferencedStandard.iconStyleClass}"
                                             required="true" styleClass="form-control" style="width:95%; display:initial;">
                                    <a4j:ajax event="blur" render="iconPathDecoration" execute="@this"/>
                                </h:inputText>
                                -->
                                <rich:autocomplete id="iconPathId" style="width:95%; display:inline-block;"
                                                   mode="ajax"  value="#{referencedStandardBeanGui.selectedReferencedStandard.iconStyleClass}" autocompleteList="#{referencedStandardBeanGui.icons}"
                                               autofill="true" required="true" var="icon" fetchValue="#{referencedStandardBeanGui.selectedReferencedStandard.iconStyleClass}" layout="table">
                                    <rich:column>
                                        <s:span styleClass="#{icon}"/>
                                    </rich:column>
                                    <rich:column>
                                       #{icon}
                                    </rich:column>
                                    <a4j:ajax event="blur" render="iconPathDecoration" execute="@this"/>
                                </rich:autocomplete>
                                <s:span styleClass="#{referencedStandardBeanGui.selectedReferencedStandard.iconStyleClass}"/>
                            </s:decorate>

                        </div>

                        <ui:define name="panel_footer">
                            <em class="pull-right">* #{messages['net.ihe.gazelle.evsclient.Required']}</em>
                        </ui:define>
                    </ui:decorate>

                    <ui:decorate template="/layout/panels/_panel_title.xhtml">
                        <ui:define name="panel_title">
                            <h:outputText value="#{messages['net.ihe.gazelle.EVSClient-ui.StylesheetAssociatedToTheStandard']}"/>
                        </ui:define>

                        <s:div id="stylesheetdiv">

                            <h:outputText value="#{messages['net.ihe.gazelle.evs.XSLLocation']} :"
                                          style="font-weight:bold;"/>
                            <a4j:commandLink styleClass="action"
                                             render="CommentSampleForm"
                                             oncomplete="jq162('#EditStylesheet').modal('show');"
                                             onRowMouseOver="this.style.cursor='pointer'"
                                             action="#{referencedStandardBeanGui.initSelectedStyleSheet()}" execute="@this">
                                <s:span styleClass="gzl-icon-plus text-info"/>
                            </a4j:commandLink>
                            <h:outputText
                                    value="#{messages['net.ihe.gazelle.evs.IfThisStandardDescribesAnXMLContentYouCanProvide']}"/>
                            <rich:dataTable
                                    rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                    value="#{referencedStandardBeanGui.selectedReferencedStandard.objectStylesheets}"
                                    rendered="#{!referencedStandardBeanGui.selectedReferencedStandard.objectStylesheets.isEmpty()}"
                                    var="currentStyleSheet"
                                    iterationStatusVar="it">
                                <g:column sortBy="#{currentStyleSheet.name}" sortOrder="ascending">
                                    <ui:define name="header">#{messages['net.ihe.gazelle.evs.Name']}</ui:define>
                                    <h:outputText value="#{currentStyleSheet.name}"/>
                                </g:column>
                                <g:column sortBy="#{currentStyleSheet.location}" sortOrder="ascending">
                                    <ui:define name="header">#{messages['net.ihe.gazelle.evs.Path']}</ui:define>
                                    <h:outputText value="#{currentStyleSheet.location}"/>
                                </g:column>
                                <g:column>
                                    <ui:define name="header">#{messages['gazelle.common.Action']}</ui:define>
                                    <s:div styleClass="gzl-never-wrap">
                                        <a4j:commandLink styleClass="action"
                                                         action="#{referencedStandardBeanGui.setSelectedStylesheet(currentStyleSheet)}"
                                                         onRowMouseOver="this.style.cursor='pointer'"
                                                         render="CommentSampleForm"
                                                         oncomplete="jq162('#EditStylesheet').modal('show');"
                                                         execute="@this">
                                            <s:span styleClass="gzl-icon-pencil text-info"/>
                                        </a4j:commandLink>
                                        <a4j:commandLink styleClass="action"
                                                         action="#{referencedStandardBeanGui.setSelectedStylesheet(currentStyleSheet)}"
                                                         onRowMouseOver="this.style.cursor='pointer'"
                                                         render="DeleteSelectedStyleSheet"
                                                         oncomplete="jq162('#DeleteSelectedStyleSheet').modal('show');"
                                                         execute="@this">
                                            <a4j:param value="#{it.index}" assignTo="#{referencedStandardBeanGui.stylesheetIndex}" />
                                            <s:span styleClass="gzl-icon-trash-o text-info"/>
                                        </a4j:commandLink>

                                    </s:div>
                                </g:column>
                            </rich:dataTable>
                        </s:div>
                    </ui:decorate>

                    <ui:decorate template="/layout/panels/_panel_title.xhtml">

                        <ui:define name="panel_title">
                            <h:outputText value="#{messages['net.ihe.gazelle.evs.AssociatedValidationServices']}"/>
                        </ui:define>

                        <h:outputText value="#{messages['net.ihe.gazelle.evs.LinkedValidationServices']}"
                                      style="font-weight:bold;"/>
                        <rich:dataTable value="#{referencedStandardBeanGui.selectedReferencedStandard.configurations}"
                                        id="validationServices" var="inValidationService" rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                        render="ds1">
                            <ui:include src="/administration/validationServiceColumns.xhtml">
                                <ui:param name="validationService" value="#{inValidationService}"/>
                                <ui:param name="referencedStandardBeanGui" value="#{referencedStandardBeanGui}"/>
                            </ui:include>
                            <g:column>
                                <a4j:commandLink styleClass="action"
                                                 title="#{messages['net.ihe.gazelle.evs.Remove']}"
                                                 actionListener="#{referencedStandardBeanGui.removeValidationService(inValidationService)}"
                                                 onRowMouseOver="this.style.cursor='pointer'" execute="@this"
                                                 render="validationServices availableValidationServices">
                                    <s:span styleClass="gzl-icon-times text-info"/>
                                </a4j:commandLink>

                            </g:column>
                            <f:facet name="footer">
                                <ui:include src="/util/datatableFooter.xhtml">
                                    <ui:param name="dataScrollerId" value="ds1"/>
                                    <ui:param name="dataTableId" value="validationServices"/>
                                </ui:include>
                            </f:facet>
                        </rich:dataTable>

                        <h:outputText value="#{messages['net.ihe.gazelle.evs.AvailableValidationServices']}"
                                      style="font-weight:bold;"/>
                        <rich:dataTable id="availableValidationServices" value="#{referencedStandardBeanGui.getAvailableValidationServices()}"
                                        var="outValidationService"
                                        rows="#{dataScrollerMemory.numberOfResultsPerPage}" render="ds2">
                            <ui:include src="/administration/validationServiceColumns.xhtml">
                                <ui:param name="validationService" value="#{outValidationService}"/>
                                <ui:param name="referencedStandardBeanGui" value="#{referencedStandardBeanGui}"/>
                            </ui:include>
                            <g:column>
                                <a4j:commandLink styleClass="action"
                                                 title="#{messages['net.ihe.gazelle.evs.Add']}"
                                                 actionListener="#{referencedStandardBeanGui.addValidationService(outValidationService)}"
                                                 onRowMouseOver="this.style.cursor='pointer'" execute="@this"
                                                 render="validationServices availableValidationServices">
                                    <s:span styleClass="gzl-icon-plus text-info"/>
                                </a4j:commandLink>

                            </g:column>
                            <f:facet name="footer">
                                <ui:include src="/util/datatableFooter.xhtml">
                                    <ui:param name="dataScrollerId" value="ds2"/>
                                    <ui:param name="dataTableId" value="availableValidationServices"/>
                                </ui:include>
                            </f:facet>
                        </rich:dataTable>
                    </ui:decorate>

                    <a4j:commandButton value="#{messages['net.ihe.gazelle.evs.SaveChanges']}"
                                       action="#{referencedStandardBeanGui.save()}" styleClass="gzl-btn-blue"
                                       render="globalDiv" execute="@form"/>
                    <h:outputLink title="#{messages['net.ihe.gazelle.evs.BackToList']}" value="referencedStandards.seam"
                                  styleClass="gzl-btn">
                        <h:outputText value="#{messages['net.ihe.gazelle.evs.BackToList']}"/>
                    </h:outputLink>
                </s:div>

            </h:form>

        </ui:decorate>


        <h:form id="CommentSampleForm" ajaxSubmit="true">
            <s:token allowMultiplePosts="true"/>

            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="EditStylesheet"/>
                <ui:define name="popup_title">
                    <h:outputText value="#{messages['net.ihe.gazelle.evs.EditStylesheet']}"/>
                </ui:define>
                <div class="form-horizontal">

                    <s:decorate id="nameDecoration" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:param name="id" value="label2Id"/>
                        <ui:define name="label">#{messages['gazelle.evs.client.Name']}</ui:define>
                        <h:inputText id="label2Id" maxlength="250" required="true"
                                     requiredMessage="You need to provide a name"
                                     value="#{referencedStandardBeanGui.selectedStylesheet.name}" styleClass="form-control">
                            <a4j:ajax event="blur" render="nameDecoration" execute="@this"/>
                        </h:inputText>

                    </s:decorate>
                    <s:decorate id="pathDecoration" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:param name="id" value="pathId"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.evs.Path_2']}</ui:define>
                        <h:inputText id="pathId" size="60" maxlength="250" required="true"
                                     requiredMessage="You need to provide a path"
                                     value="#{referencedStandardBeanGui.selectedStylesheet.location}" styleClass="form-control">
                            <a4j:ajax event="blur" render="pathDecoration" execute="@this"/>
                        </h:inputText>
                    </s:decorate>
                </div>
                <ui:define name="popup_footer">
                    <a4j:commandButton value="#{messages['net.ihe.gazelle.evs.Cancel']}"
                                       styleClass="gzl-btn" execute="@this"
                                       oncomplete="jq162('#EditStylesheet').modal('hide');"/>

                    <a4j:commandButton value="#{messages['gazelle.evs.Save']}" styleClass="gzl-btn-blue"
                                       actionListener="#{referencedStandardBeanGui.saveSelectedStylesheet()}"
                                       oncomplete="jq162('#EditStylesheet').modal('hide');"
                                       render="globalForm:stylesheetdiv"/>

                </ui:define>
            </ui:decorate>


            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="DeleteSelectedStyleSheet"/>
                <ui:define name="popup_title">
                    <h:outputText value="#{messages['net.ihe.gazelle.evs.DeleteStylesheet']}"/>
                </ui:define>
                <h:outputText
                        value="#{messages['net.ihe.gazelle.evs.AreYouSureYouWantToDeleteTheStylesheet']} #{referencedStandardBeanGui.selectedStylesheet.name} ?"/>

                <ui:define name="popup_footer">
                    <a4j:commandButton value="#{messages['net.ihe.gazelle.evs.Cancel']}"
                                       onclick="jq162('#DeleteSelectedStyleSheet').modal('hide');"
                                       styleClass="gzl-btn" execute="@this"/>
                    <a4j:commandButton value="#{messages['net.ihe.gazelle.evs.Confirm']}" styleClass="gzl-btn-red"
                                       actionListener="#{referencedStandardBeanGui.deleteSelectedStylesheet()}"
                                       oncomplete="jq162('#DeleteSelectedStyleSheet').modal('hide');" execute="@this"
                                       render="globalForm:stylesheetdiv"/>

                </ui:define>
            </ui:decorate>
        </h:form>
    </ui:define>
</ui:composition>

